#!/bin/sh
# 
# Module-dependent initscript
# 
# copyleft 2003, Alex de Landgraaf
# GPL, (www.gnu.org for details)
#
# $Id: init.sh,v 1.5 2004/04/12 00:06:03 paul_c Exp $
#
# This is a placeholder adapted for the HeavyGUI mainmodule
# Place actions to be started on initialisation
# of your MainModule in here

USER=morph
WINDOWMANAGER=kde3
INSTALLED=no
XSERVER=XFree86
PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin:."

export PATH

# load the config's generated by our basemodule
XMODULE=""
[ -f /etc/sysconfig/xserver ] && . /etc/sysconfig/xserver
[ -f /etc/sysconfig/morphix-all ] && . /etc/sysconfig/morphix-all

echo "MainModule loaded"

[ -f /etc/sysconfig/xserver ] && . /etc/sysconfig/xserver
[ -f /etc/sysconfig/morphix-all ] && . /etc/sysconfig/morphix-all
[ -f /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
[ -f /etc/sysconfig/i18n ] && . /etc/sysconfig/i18n

export LANG COUNTRY CHARSET

[ -f /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
# Set default keyboard before interactive setup
[ -n "$KEYTABLE" ] && loadkeys -q $KEYTABLE
[ -n "$CONSOLEFONT" ] && consolechars -f $CONSOLEFONT

# Try to find and load a drm module for this graphics card
# ripped from Knopper's xsession
if [ -n "$XMODULE" ]; then
for i in /lib/modules/*/kernel/drivers/char/drm/*; do
case "$i" in *$XMODULE*) modprobe $XMODULE;; esac
done
fi

stringinfile(){
case "$(cat $2)" in *$1*) return 0;; esac
return 1
}

# automount test, also thanks to popular demand...
# This all has too been ripped from Knopper's knoppix-autoconfig
# Personally, i really suck at shell :o)

if [ -e /etc/init.d/cupsys ]; then
/etc/init.d/cupsys start &
fi
#mount -avF -o ro -t nonfs,nosmbfs,noncpfs,noproc

# Check if there isn't a background in /tmp (for minimodule)
# Actually, this should be done for each initscript too,
# as it would make them adaptable for minimodules...

if [ -e /tmp/background.png ]; then
BGIMAGE=/tmp/background.png
else
BGIMAGE=/morphix/background.png
fi

# Starting X and windowmanager

#for X in normal vesa fbdev
#do
#   /usr/bin/X11/$XSERVER -kb :0 &
#   
#   if /usr/bin/X11/$XSERVER -kb -depth 16 :0 || \
#       /usr/bin/X11/$XSERVER -kb -depth 24 :0 || \
#       /usr/bin/X11/$XSERVER -kb -depth 32 :0 || \
#       /usr/bin/X11/$XSERVER -kb -depth 8 :0; then break; fi
#done &

if [ $INSTALLED = no ]; then
# Setting up our handy-dandy console-shells, thanks to popular demand...
# ripped from Knopper's knoppix-autoconfig
    while true; do /bin/bash >/dev/tty2 2>&1 </dev/tty2; done &
    while true; do /bin/bash >/dev/tty3 2>&1 </dev/tty3; done &
    while true; do /bin/bash >/dev/tty4 2>&1 </dev/tty4; done &
    while true; do /bin/bash >/dev/tty5 2>&1 </dev/tty5; done &

    echo "allowed_users=anybody" >> /etc/X11/Xwrapper.config
    echo "nice_value=-10" >> /etc/X11/Xwrapper.config

    echo "xsetbg -fullscreen $BGIMAGE &" >> /etc/X11/xinit/xinitrc
    echo "xsetbg -fullscreen $BGIMAGE &" >> /home/$USER/.xinitrc
    echo "xsetbg -fullscreen $BGIMAGE &" >> /home/$USER/.xsession

    echo "exec $WINDOWMANAGER" >> /etc/X11/xinit/xinitrc
    echo "exec $WINDOWMANAGER" >> /home/$USER/.xinitrc
    echo "exec $WINDOWMANAGER" >> /home/$USER/.xsession

    su -c"exec /usr/bin/X11/startx" - $USER

# wait until X is locked



    for i in 1 2 3 4 5 6 7 8 9 10
      do
      if [ -f /tmp/.X0-lock ]; then
	  break
	  sleep 1
      fi
    done

# set background, start windowmanager
#su -c "DISPLAY=:0 exec xsetbg -fullscreen -onroot $BGIMAGE &" - $USER >/dev/null 2>&1
#su -c "DISPLAY=:0 exec $WINDOWMANAGER" - $USER > /dev/null 2>&1

    for i in $XSERVER; do
	killall -TERM $i 2> /dev/null && echo "X-Server shut down." && break
    done
fi
echo "Rebooting... (disabled, just to be sure, for now)"
echo "Use reboot or halt to shutdown your computer"

#exec reboot
